﻿using System;
using System.Collections.Generic;
using System.Configuration;
using System.Data.SqlClient;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace FillListFromTextFile
{
    class Program
    {
        static void Main(string[] args)
        {
            List<Person> lst = null;

            string strFileReader = string.Empty,
                strBuffer = string.Empty;

            strFileReader = ConfigurationManager.AppSettings["FileReader"].ToString();

            strBuffer = File.ReadAllText(strFileReader);

            lst = GetListPerson(strBuffer);

            SqlCommand sqlCommand = new SqlCommand();
            sqlCommand.Connection = OpenDB();

            foreach (Person item in lst)
            {
                string insert_query = "insert into person (firstName, lastName, gender, country, age, date, id) " +
                    "                              values (@argFirstName, @argLastName, @argGender, @argCountry, @argAge, @argDate, @argId)";

                sqlCommand = new SqlCommand(insert_query, sqlCommand.Connection);

                sqlCommand.Parameters.AddWithValue("@argFirstName", item.FirstName);
                sqlCommand.Parameters.AddWithValue("@argLastName", item.LastName);
                sqlCommand.Parameters.AddWithValue("@argGender", item.Gender);
                sqlCommand.Parameters.AddWithValue("@argCountry", item.Country);
                sqlCommand.Parameters.AddWithValue("@argAge", item.Age);
                sqlCommand.Parameters.AddWithValue("@argDate", item.Date);
                sqlCommand.Parameters.AddWithValue("@argId", item.Id);

                sqlCommand.ExecuteNonQuery();

                insert_query = string.Empty;
            }
            sqlCommand.Connection.Close();

        }

        static List<Person> GetListPerson(string strBuffer)
        {
            int i = 0;
            List<Person> lst = new List<Person>();

            foreach(string str in strBuffer.Split(new string[] { "\n"},StringSplitOptions.None))
            {
                string[] aryStr = str.Split(new char[] { ','}, StringSplitOptions.None);

                Person p = new Person();

                for(i = 0; i<aryStr.Length;i++)
                {
                    switch (i)
                    {
                        case 0:
                            p.FirstName = aryStr[i];
                            break;
                        case 1:
                            p.LastName = aryStr[i];
                            break;
                        case 2:
                            p.Gender = Convert.ToBoolean(aryStr[i]);
                            break;
                        case 3:
                            p.Country = aryStr[i];
                            break;
                        case 4:
                            p.Age = Convert.ToInt32(aryStr[i]);
                            break;
                        case 5:
                            p.Date = Convert.ToDateTime(aryStr[i]);
                            break;
                        case 6:
                            p.Id = aryStr[i];
                            break;
                    }
                }
             
                lst.Add(p);
            }
            return lst;
        }

        static public SqlConnection OpenDB()
        {
            SqlConnection sqlConn = new SqlConnection(ConfigurationManager.ConnectionStrings["ConnString"].ConnectionString);
            try
            {
                sqlConn.Open();
            }
            catch (SqlException ex)
            {
                throw new Exception(ex.Message, ex);
            }
            return sqlConn;
        }
    }
}
